abuild.in 22.8 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
apkcache=@apkcache@
Natanael Copa's avatar
Natanael Copa committed
14 15 16

startdir="$PWD"
srcdir=${srcdir:-"$startdir/src"}
17
pkgbasedir=${pkgbasedir:-"$startdir/pkg"}
Natanael Copa's avatar
Natanael Copa committed
18
pkgrel=0
Natanael Copa's avatar
Natanael Copa committed
19 20
repo=${startdir%/*}
repo=${repo##*/}
Natanael Copa's avatar
Natanael Copa committed
21 22 23 24

# defaults
SRCDEST=${SRCDEST:-$startdir}
PKGDEST=${PKGDEST:-$startdir}
25
BUILD_BASE="build-base"
Natanael Copa's avatar
Natanael Copa committed
26

27 28
SUDO=${SUDO:-"sudo"}

29
default_cmds="sanitycheck builddeps clean fetch unpack rootpkg apkcache"
Natanael Copa's avatar
Natanael Copa committed
30

Natanael Copa's avatar
Natanael Copa committed
31
# read config
Natanael Copa's avatar
Natanael Copa committed
32
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
33 34
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

35
# source functions
36 37
datadir=/usr/share/abuild

Natanael Copa's avatar
Natanael Copa committed
38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69
#colors
if [ -n "$USE_COLORS" ]; then
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
fi	
	

# functions
msg() {
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	[ -z "$quiet" ] && printf "${prompt} ${name}${fake}: $@\n" >&2
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}
70 71

	
Linux User's avatar
Linux User committed
72 73
set_xterm_title() {
	if [ "$TERM" = xterm ]; then
74
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
75 76 77 78 79
	fi
} 

cleanup() {
	set_xterm_title ""
80
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
81
		$SUDO apk del $uninstall_after
82
	fi
Linux User's avatar
Linux User committed
83 84
}

Natanael Copa's avatar
Natanael Copa committed
85
die() {
Linux User's avatar
Linux User committed
86
	error "$@"
Linux User's avatar
Linux User committed
87
	cleanup
Natanael Copa's avatar
Natanael Copa committed
88 89 90
	exit 1
}

91 92
# check if apkbuild is basicly sane
sanitycheck() {
Natanael Copa's avatar
Natanael Copa committed
93
	local i
94
	msg "Checking sanity of $APKBUILD..."
95 96 97
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
98 99
	apk version --check -q "$pkgver" ||\
		die "$pkgver is not a valid version"
100 101 102 103 104
	[ -z "$pkgrel" ] && warning "Missing pkgrel in APKBUILD. Using pkgrel=0"
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

105 106 107
	if [ -n "$source" ]; then
		for i in $source; do
			md5sums_has ${i##*/} || die "${i##*/} is missing in md5sums"
108 109 110
			case "$i" in
				https://*) makedepends_has wget || die "wget must be in makedepends when source has https://" ;;
			esac
111 112
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
113

114 115 116 117 118
	if [ -n "$md5sums" ]; then
		for i in $(echo "$md5sums" | awk '{ print $2 }'); do
			source_has $i || die "$i is missing in source"
		done
	fi
119

120 121 122
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
123 124

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
125 126

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
127 128 129 130
	return 0
}

md5check() {
Natanael Copa's avatar
Natanael Copa committed
131
	local dummy f
132 133 134
	if [ -z "$source" ]; then
		return 0
	fi
135
	if [ -z "$md5sums" ]; then
136
		die "Use 'abuild checksum' to generate/update the checksum(s)"
137
	fi
138 139 140
	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi
141
	fetch || return 1
142
	msg "Checking md5sums..."
143
	cd "$srcdir" && echo "$md5sums" | md5sum -c 
Natanael Copa's avatar
Natanael Copa committed
144 145 146 147 148
}

uri_fetch() {
	local uri="$1"
	local d="${s##*/}"	# $(basename $s)
149 150 151 152
	local opts
	[ -n "$quiet" ] && opts="-q"
	[ -f "$SRCDEST/$d" ] && return 0

153 154 155 156 157 158
	
	# we need GNU wget for this
	case "$uri" in
		https://*) opts="--no-check-certificate";;
	esac
	
Natanael Copa's avatar
Natanael Copa committed
159
	mkdir -p "$SRCDEST"
160 161 162
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
		opts="$opts -c"
Natanael Copa's avatar
Natanael Copa committed
163
	fi
Linux User's avatar
Linux User committed
164
	msg "Fetching $uri"
165 166
	wget $opts -O "$SRCDEST/$d.part" "$uri" \
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
Natanael Copa's avatar
Natanael Copa committed
167 168
}

169 170
is_remote() {
	case "$1" in
171
		http://*|ftp://*|https://*)
172 173 174 175 176
			return 0;;
	esac
	return 1
}

Natanael Copa's avatar
Natanael Copa committed
177 178 179
fetch() {
	local s
	mkdir -p "$srcdir"
180 181 182 183 184 185 186
	for s in $source; do
		if is_remote "$s"; then
			uri_fetch "$s" || return 1
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
187 188 189 190 191 192
	done
}

# unpack the sources
unpack() {
	local u
193
	md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
194 195 196 197
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
Natanael Copa's avatar
Natanael Copa committed
198
			*.tar.gz|*.tgz)
199
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
200 201
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
202
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
203
				tar -C "$srcdir" -jxf "$s" || return 1;;
204 205 206 207
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
Natanael Copa's avatar
Natanael Copa committed
208 209 210
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
211 212 213 214 215 216
		esac
	done
}

# cleanup source and package dir
clean() {
217
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
218
	rm -rf "$srcdir"
219
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
220 221 222 223 224 225
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
226 227 228 229
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
230 231 232 233 234
	done
}

cleanpkg() {
	local i
235
	msg "Cleaning built packages..."
236
	for i in $pkgname $subpackages; do
237 238
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
239
			"$apkcache"/$p.apk
Natanael Copa's avatar
Natanael Copa committed
240
	done
241
	# remove given packages from index
Natanael Copa's avatar
Natanael Copa committed
242 243
}

244 245 246 247 248 249 250 251 252 253 254 255 256
# clean all packages except current
cleanoldpkg() {
	local i j
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
	for i in $pkgname $subpackages; do
		for j in "$PKGDEST"/${i%:*}-[0-9]*.apk; do
			[ "$j" != "$PKGDEST/${i%:*}-$pkgver-r$pkgrel.apk" ] \
				&& rm -f "$j"
		done
	done
	return 0
}
	
Natanael Copa's avatar
Natanael Copa committed
257 258
runpart() {
	local part=$1
259
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
260 261 262 263 264 265 266 267
	$part || die "$part failed"
}

# override those in your build script
build() {
	die "No build() function found in $APKBUILD"
}

268 269 270 271 272 273 274 275 276
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

277
prepare_subpackages() {
278
	if [ -z "$subpackages" ]; then
279 280
		return 0
	fi
Natanael Copa's avatar
Natanael Copa committed
281 282
	local i
	cd "$startdir"
283
	for i in $subpackages; do
284 285
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
286
		msg "Running split function $func..."
287
		subpkgdir="$pkgbasedir/${i%:*}" subpkgname="${i%:*}" \
288
			$0 $func prepare_package || return 1
Natanael Copa's avatar
Natanael Copa committed
289 290 291
	done
}

292
prepare_metafiles() {
293 294
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
295
	local dir=${subpkgdir:-$pkgdir}
296
	local pkg="$name-$pkgver-r$pkgrel.apk"
297
	local pkginfo="$controldir"/.PKGINFO
298
	local sub
Natanael Copa's avatar
Natanael Copa committed
299 300 301
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
302
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
303 304 305
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')

306
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
307
	if [ -n "$FAKEROOTKEY" ]; then
308
		echo "# using $(fakeroot -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
309
	fi
310 311
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
312
pkgname = $name
313
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
314 315 316 317 318 319
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
EOF
320 321
	local i deps
	deps="$depends"
322 323 324 325 326 327 328 329
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
		for i in $install; do
			if head -n 1 "$srcdir/$i" | grep '^#!/bin/sh' >/dev/null ; then
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
330 331
	fi
	
Natanael Copa's avatar
Natanael Copa committed
332
	for i in $license; do
333
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
334 335
	done
	for i in $replaces; do
336
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
337
	done
338
	for i in $deps; do
339
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
340 341
	done
	for i in $conflicts; do
342
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
343 344
	done
	for i in $provides; do
345
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
346 347
	done
	for i in $backup; do
348
		echo "backup = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
349 350 351
	done

	local metafiles=".PKGINFO"
352 353 354 355 356 357 358 359 360 361
	for i in $install; do
		script=${i#$name}
		case "$script" in
			.pre-install|.post-install|.pre-upgrade|.post-upgrade|.pre-deinstall|.post-deinstall)
				msg "Adding $script"
				;;
			*) 	error "$script: Invalid install script"
				return 1
				;;
		esac
362 363
		cp "$srcdir/$i" "$controldir/$script" || return 1
		chmod +x "$controldir/$script"
364 365
		metafiles="$metafiles $script"
	done
366
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
367
}
368

369 370 371
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
	options_has "!tracedeps" && return 0
372 373
	find -name '*.so' -o -name '*.so.[0-9]*' | sed 's:.*/::' \
		>"$controldir"/.provides-so
374
	scanelf -Rn "$dir" | awk -F "\ " '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
375 376 377
		| sed 's:,:\n:g' | sort | uniq \
	| while read i; do
		# only add files that are not self provided
378 379
		grep "^$i$" "$controldir"/.provides-so >/dev/null \
			|| echo $i >> "$controldir"/.needs-so
380
	done
Natanael Copa's avatar
Natanael Copa committed
381 382
}

383
prepare_package() {
384
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
385
	stripbin
386
	prepare_metafiles
387
	prepare_tracedeps
388 389 390 391 392 393 394 395
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

396 397 398
trace_apk_deps() {
	local name="$1"
	local dir="$2"
399 400
	local i j found autodeps=
	msg "Tracing dependencies for $name..."
401
	for i in $(cat "$dir"/.needs-so 2>/dev/null); do
402
		found=
403
		# first check if its provide by same apkbuild
404
		for j in "$dir"/../.control.*/.provides-so; do
405
			grep -w "$i" "$j" >/dev/null || continue
406
			found=${j%/.provides-so}
407
			found=${found##*/.control.}
408
			break
409 410 411 412 413 414 415 416 417 418 419 420 421
		done
		# check apk db if not provided by a subpackage
		if [ -z "$found" ]; then
			found=$(apk info -q -W /lib/$i /usr/lib/$i)
		fi
		if [ -z "$found" ]; then
			error "Could not find dependency for $i"
			return 1
		fi
		if grep -w "^depend = $found" "$dir"/.PKGINFO >/dev/null ; then
			warning "You can remove '$found' from depends"
			continue
		fi
422 423
		list_has "$found" $autodeps || autodeps="$autodeps $found"
		msg "Added '$found' as dependency as it has $i"
424 425 426 427 428 429 430 431
	done
	[ -z "$autodeps" ] && return 0
	echo "# automatically detected:" >> "$dir"/.PKGINFO
	for i in $autodeps; do
		echo "depend = $i" >> "$dir"/.PKGINFO
	done
}

432 433
create_apks() {
	local file
434
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
435 436 437
		local dir="${file%/.PKGINFO}"
		local name=$(pkginfo_val pkgname $file)
		local ver=$(pkginfo_val pkgver $file)
438
		local apk=$name-$ver.apk
439
		local datadir="$pkgbasedir"/$name
440 441

		trace_apk_deps "$name" "$dir" || return 1
442
		msg "Creating $apk..."
443
		(
444 445 446 447 448 449 450 451 452
		cd "$datadir"
		# data.tar.gz
		tar -c . | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz

		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
453
		cd "$dir"
454 455
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
Natanael Copa's avatar
Natanael Copa committed
456

457 458 459
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
	)
460 461 462
	done
}

463
apkcache() {
464
	if ! apk_up2date || [ -n "$force" ]; then
465 466 467
		sanitycheck && builddeps && clean && fetch && unpack && rootpkg || return 1
	fi
	local apk
468
	mkdir -p "$apkcache" || return 1
469
	set --
470
	for apk in $(listpkg); do
471
		ln -sf "$PKGDEST"/$apk "$apkcache"/$apk
472 473
	done

474
	# update the apkcache cache here
475
	msg "Updating the cached abuild repository index..."
476 477 478 479 480 481 482 483 484 485 486 487
	(
	local sign=".SIGN.RSA.${SIGN_PUBLIC_KEY##*/}"
	local oldindex=
	cd "$apkcache"
	if [ -f APKINDEX.tar.gz ]; then
		oldindex="--index APKINDEX.tar.gz"
	fi
	apk index $oldindex --output APKINDEX.tar.gz.unsigned *.apk || exit 1
	msg "Signing the index..."
	abuild-sign -q APKINDEX.tar.gz.unsigned || exit 1
	mv APKINDEX.tar.gz.unsigned APKINDEX.tar.gz
	)
488 489
}

490
# predefined splitfunc doc
491
default_doc() {
492
	depends="$depends_doc"
493
	install="$install_doc"
Natanael Copa's avatar
Natanael Copa committed
494
	local i
495
	for i in doc man info html sgml licenses gtk-doc; do
496 497 498
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
499 500
		fi
	done
501 502 503
	
	rm -f "$subpkgdir/usr/share/info/dir"

504 505 506
#	# compress info and man pages
#	find "$subpkgdir/usr/share" \( -name '*.info' -o -name '*.info-[1-9]' \
#		-o -name '*.[1-9]' \) -exec gzip {} \;
507 508 509 510

	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

Natanael Copa's avatar
Natanael Copa committed
511
#	[ -d "$subpkgdir/usr/share/man" ] && depends="man"
Natanael Copa's avatar
Natanael Copa committed
512 513 514
	return 0
}

515 516 517 518
doc() {
	default_doc
}

519
# predefined splitfunc mod
520
default_mod() {
521
	depends="$kernel $depends_mod"
522
	install="$install_mod"
Natanael Copa's avatar
Natanael Copa committed
523
	for i in firmware modules; do
524 525 526
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
527
			mv "$pkgdir/lib/$i" "$subpkgdir/lib"
Natanael Copa's avatar
Natanael Copa committed
528 529 530 531
		fi
	done
}

532 533 534 535
mod() {
	default_mod
}

536
# predefined splitfunc dev
537
default_dev() {
538
	depends="$pkgname $depends_dev"
539
	install="$install_dev"
540
	cd "$pkgdir" || return 0
541 542 543 544 545
	for i in usr/include usr/lib/pkgconfig usr/share/aclocal\
			usr/share/gettext usr/bin/*-config	\
			$(find -name include -type d) 		\
			$(find usr/ -name '*.[acho]' -o -name '*.la' \
			2>/dev/null); do
546 547
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
548
			mkdir -p "$d"
549
			mv "$pkgdir/$i" "$d"
550
			rmdir "$pkgdir/${i%/*}" 2>/dev/null
Natanael Copa's avatar
Natanael Copa committed
551 552
		fi
	done
Natanael Copa's avatar
Natanael Copa committed
553
	return 0
Natanael Copa's avatar
Natanael Copa committed
554 555
}

556 557 558 559
dev() {
	default_dev
}

Natanael Copa's avatar
Natanael Copa committed
560 561
# build and package in fakeroot
rootpkg() {
Natanael Copa's avatar
Natanael Copa committed
562
	cd "$startdir"
563
	msg "Entering fakeroot..."
564
	fakeroot $0 build prepare_subpackages prepare_package create_apks
Natanael Copa's avatar
Natanael Copa committed
565 566 567
}

srcpkg() {
568
	local p="$pkgname-$pkgver-$pkgrel"
Natanael Copa's avatar
Natanael Copa committed
569
	local prefix="${startdir##*/}"
Natanael Copa's avatar
Natanael Copa committed
570 571 572 573 574
	local i files="$prefix/APKBUILD"
	for i in $source; do
		files="$files $prefix/${i##*/}"
	done
	mkdir -p "$PKGDEST"
575
	msg "Creating source package $p.src.tar.gz..."
576
	(cd .. && tar -zcf "$PKGDEST/$p.src.tar.gz" $files) 
Natanael Copa's avatar
Natanael Copa committed
577 578
}

579
# check if package is up to date
580
apk_up2date() {
581
	local pkg="$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk"
582
	local i s
Natanael Copa's avatar
Natanael Copa committed
583
	cd "$startdir"
584 585 586 587 588
	for i in $pkgname $subpackages; do
		[ -f "$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk" ] || return 1
	done
	[ -n "$keep" ] && return 0

589
	for i in $source APKBUILD; do
590 591 592 593 594 595
		local s
		if is_remote "$i"; then
			s="$SRCDEST/${i##*/}"	# $(basename $i)
		else
			s="$startdir/${i##*/}"
		fi
596 597 598 599 600 601 602
		if [ "$s" -nt "$pkg" ]; then
			return 1
		fi
	done
	return 0
}

603 604 605 606 607 608 609 610 611 612 613 614 615
cache_up2date() {
	local i apk
	for i in $pkgname $subpackages; do
		apk="${i%:*}-$pkgver-r$pkgrel.apk"
		[ "$apkcache"/APK_INDEX.gz -nt "$apkcache"/$apk ] || return 1
	done
	return 0
}

up2date() {
	apk_up2date && cache_up2date
}

616 617 618 619 620 621 622 623 624 625 626 627 628
# source all APKBUILDs and output:
#  1) origin of package
#  2) all dependencies
# the output is i in a format easy parseable for awk
depparse_aports() {
	# lets run this in a subshell since we source all APKBUILD here
	(
	aportsdir=$(realpath ${APKBUILD%/APKBUILD}/../..)
	for i in $aportsdir/*/*/APKBUILD; do
		pkgname=
		subpackages=
		depends=
		makedepends=
629
		. $i
630
		dir=${i%/APKBUILD}
631 632 633 634 635 636 637 638
		deps=
		# filter out conflicts from deps
		for j in $depends $makedepends; do
			case "$j" in
				!*) continue;;
			esac
			deps="$deps $j"
		done
639
		for j in $pkgname $subpackages; do
640
			echo "o ${j%%:*} $dir"
641
			set -- $deps
642 643 644 645 646 647 648
			echo -n "d ${j%%:*} $1"
			shift
			while [ $# -gt 0 ]; do
				echo -n ",$1"
				shift
			done
			echo
649 650
		done
	done
651
	)
652 653
}

654
deptrace() {
655 656
	local deps="$@"
	[ -z "$deps" ] && deps="$BUILD_BASE $depends $makedepends"
657 658 659
	( 	depparse_aports 
		if [ -z "$upgrade" ]; then
			# list installed pkgs and prefix with 'i '
Natanael Copa's avatar
Natanael Copa committed
660
			apk info -q | sort |  sed 's/^/i /'
661
		fi
662
	) | awk -v pkgs="$deps" '
663 664 665 666 667 668 669 670 671 672 673 674 675 676 677 678 679 680 681 682 683 684 685 686 687

	function depgraph(pkg,	a, i) {
		if (visited[pkg])
			return 0;
		visited[pkg] = 1;
		split(deps[pkg], a, ",");
		for (i in a)
			depgraph(a[i]);
		print pkg ":" origin[pkg];

	}

	$1 == "i" { visited[$2] = 1 }
	$1 == "o" { origin[$2] = $3 }
	$1 == "d" { deps[$2] = $3 }
	END {
		split(pkgs, pkgarray);
		for (i in pkgarray)
			depgraph(pkgarray[i]);
	}
	'
}

# build and install dependencies
builddeps() {
688 689
	local deps alldeps pkg i dir ver missing installed_deps
	msg "Analyzing dependencies..."
690 691
	deps="$BUILD_BASE $makedepends"

692

693 694 695 696 697
	# add depends unless it is a subpackage
	for i in $depends; do
		subpackages_has $i || deps="$deps $i"
	done

698
	installed_deps=$(apk info -e $deps)
699
	# find which deps are missing
700
	for i in $deps; do
701
		if [ "${i#\!}" != "$i" ]; then
702
			list_has ${i#\!} $installed_deps \
703
				&& die "Conflicting package ${i#\!} is installed."
704
		elif ! list_has $i $installed_deps; then
705 706 707 708 709 710 711
			if [ -z "$install_deps" ] && [ -z "$recursive" ]; then
				die "Missing dependency $i. Use -r to autoinstall or -R to build"
			fi
			missing="$missing $i"
		fi
	done

712 713
	[ -z "$missing" ] && [ -z "$install_deps" ] && [ -z "$recursive" ] \
		&& return 0
714

715
	uninstall_after=".makedepends-$pkgname $uninstall_after"
716
	if [ -n "$install_deps" ] && [ -z "$recursive" ]; then
717
		$SUDO apk add --repo "$apkcache" \
718 719
			--virtual .makedepends-$pkgname $deps \
			&& return 0
720
	fi
721 722 723 724
	
	[ -z "$recursive" ] && return 1
	
	for i in $(deptrace $missing); do
725 726 727 728
		# i = pkg:dir
		local dir=${i#*:}
		local pkg=${i%:*}
		msg "Entering $dir"
729
		cd "$dir" && $0 -k -r apkcache || return 1
730
	done
731
	$SUDO apk add -u --repo "$apkcache" \
732
		--virtual .makedepends-$pkgname $deps
733 734
}

735
# replace the md5sums in the APKBUILD
Natanael Copa's avatar
Natanael Copa committed
736 737
checksum() {
	local s files
738
	[ -z "$source" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
739
	fetch
740
	msg "Updating the md5sums in APKBUILD..."
Natanael Copa's avatar
Natanael Copa committed
741 742 743 744
	for s in $source; do
		files="$files ${s##*/}"
	done
	md5sums="$(cd "$srcdir" && md5sum $files)" || die "md5sum failed"
745 746
	sed -i -e '/^md5sums="/,/"\$/d; /^md5sums=''/,/''\$/d' "$APKBUILD"
	echo "md5sums=\"$md5sums\"" >>"$APKBUILD"
Natanael Copa's avatar
Natanael Copa committed
747 748
}

749
stripbin() {
750
	local bin
751
	options_has "!strip" && return 0
752 753
	cd "${subpkgdir:-$pkgdir}" || return 1
	msg "Stripping binaries"
754
	find . -type f 2>/dev/null | while read bin; do
755 756 757 758 759 760 761 762 763 764 765
		local opt=
		case "$(file -biz "$bin")" in
			*/x-sharedlib*|*/x-archive*)
				strip --strip-debug "$bin";;
			*/x-executable*)
				strip "$bin";;
		esac
	done
	return 0
}

766 767 768 769 770 771 772 773
# simply list target apks
listpkg() {
	local i 
	for i in $pkgname $subpackages; do
		echo "${i%:*}-$pkgver-r$pkgrel.apk"
	done
}

Natanael Copa's avatar
Natanael Copa committed
774 775 776 777 778 779 780 781
source_has() {
	local i
	for i in $source; do
		[ "$1" = "${i##*/}" ] && return 0
	done
	return 1
}

Natanael Copa's avatar
Natanael Copa committed
782 783 784 785 786 787 788 789
subpackages_has() {
	local i
	for i in $subpackages; do
		[ "$1" = "${i%:*}" ] && return 0
	done
	return 1
}

790 791 792 793 794 795 796 797 798 799 800 801 802 803 804
list_has() {
	local needle="$1"
	local i
	shift
	for i in $@; do
		[ "$needle" = "$i" ] && return 0
		[ "$needle" = "!$i" ] && return 1
	done
	return 1
}

options_has() {
	list_has "$1" $options
}

805 806 807 808
depends_has() {
	list_has "$1" $depends
}

809 810 811 812
makedepends_has() {
	list_has "$1" $makedepends
}

Natanael Copa's avatar
Natanael Copa committed
813 814 815 816
md5sums_has() {
	list_has "$1" $md5sums
}

Natanael Copa's avatar
Natanael Copa committed
817 818 819 820 821 822 823 824 825 826 827 828 829 830
# install package after build
post_add() {
	local pkgf="$PKGDEST/$1-$pkgver-r$pkgrel.apk"
	local deps i
	if ! subpackages_has $1 && [ "$1" != "$pkgname" ]; then
		die "$1 is not built by this APKBUILD"
	fi
	# recursively install dependencies that are provided by this APKBUILD
	deps=$(apk index "$pkgf" 2>/dev/null | awk -F: '$1=="D" { print $2 }')
	for i in $deps; do
		if subpackages_has $i || [ "$i" = "$pkgname" ]; then
			post_add $i || return 1
		fi
	done
831
	$SUDO apk add -u "$pkgf" || die "Failed to install $1"
Natanael Copa's avatar
Natanael Copa committed
832 833
}

834 835 836 837 838 839 840 841 842 843 844 845 846 847 848 849 850 851 852 853 854 855 856
# create new aport from templates
newaport() {
	local pn=${newname%-[0-9]*}
	local pv
	if [ "$pn" != "$newname" ]; then
		pv=${newname#$pn-}
	fi
	if [ -e "$pn"/APKBUILD ]; then
		error "$pn/APKBUILD already exist"
		return 1
	fi
	mkdir -p "$pn"
	cd "$pn"
	sed 	-e '1,/^\#*$/d' \
		-e "s/^\(# Contributor: \).*/\1$PACKAGER/" \
		-e "s/^\(# Maintainer: \).*/\1$PACKAGER/" \
		-e "s/^pkgname=.*/pkgname=$pn/" \
		-e "s/^pkgver=.*/pkgver=$pv/" \
		"$datadir"/sample.APKBUILD > APKBUILD || return 1
	#-e '1,/^\#$/d' \
	if [ -n "$cpinitd" ]; then
		cp "$datadir"/sample.initd $pn.initd
		cp "$datadir"/sample.confd $pn.confd
857 858 859
		cp "$datadir"/sample.pre-install $pn.pre-install
		cp "$datadir"/sample.post-install $pn.post-install
		sed -i -e "s/^install=.*/install=\"\$pkgname.pre-install \$pkgname.post-install\"/" \
860 861 862 863 864
			-e "s/^source=\"\(.*\)\"/source=\"\1\n\t$pn.initd\n\t$pn.confd\n\t\$install\n\t\"/" \
			APKBUILD
		
	fi
}
865 866

installdeps() {
867
	local deps i
868
	sudo apk add --repo "$apkcache" --virtual .makedepends-$pkgname \
869
		$makedepends
870 871 872
}

uninstalldeps (){
873
	sudo apk del .makedepends-$pkgname
874
}
875 876 877 878 879 880 881 882 883

all() {
	if up2date && [ -z "$force" ]; then
		msg "Package is up to date"
	else
		apkcache
	fi
}

Natanael Copa's avatar
Natanael Copa committed
884
usage() {
885
	echo "$(basename $0) $abuild_ver"
886 887
	echo "usage: ${0##*/} [options] [-i PKG] [-P REPODEST] [-p PKGDEST]"
	echo "              [-s SRCDEST] [cmd] ..."
888
	echo "       ${0##*/} [-c] -n PKGNAME[-PKGVER]"
Natanael Copa's avatar
Natanael Copa committed
889 890
	echo "Options:"
	echo " -f  Force specified cmd, even if they are already done"
891 892
	echo " -h  Show this help"
	echo " -i  Install PKG after successul build"
893
	echo " -k  Keep built packages, even if APKBUILD or sources are newer"
894
	echo " -p  Set package destination directory"
895
	echo " -P  Set PKGDEST to REPODEST/<repo>, where repo is the parents dir name" 
Natanael Copa's avatar
Natanael Copa committed
896
	echo " -q  Quiet"
897 898
	echo " -r  Install missing dependencies from system repository (using sudo)"
	echo " -R  Recursively build and install missing dependencies (using sudo)"
899
	echo " -s  Set source package destination directory"
900
	echo " -u  Recursively build and upgrade all dependencies (using sudo)"
Natanael Copa's avatar
Natanael Copa committed
901
	echo ""
902 903 904
	echo " -n  Create a new APKBUILD in a directory named PKGNAME"
	echo " -c  Copy a sample init.d, conf.d and install script to new directory"
	echo ""
Natanael Copa's avatar
Natanael Copa committed
905
	echo "Commands:"
906
	echo "  checksum    Generate checksum to be included in APKBUILD"
907 908 909 910 911
	echo "  fetch       Fetch sources to \$SRCDEST and verify checksums"
	echo "  sanitycheck Basic sanity check of APKBUILD"
	echo "  md5check    Check md5sums"
	echo "  unpack      Unpack sources to \$srcdir"
	echo "  build       Compile and install package into \$pkgdir"
912
	echo "  listpkg     List target packages"
913 914 915
	echo "  package     Create package in \$PKGDEST"
	echo "  rootpkg     Run '$0 build package' as fakeroot"
	echo "  clean       Remove temp build and install dirs"
916
	echo "  cleanoldpkg Remove binary packages except current version"
917 918 919 920
	echo "  cleanpkg    Remove already built binary and source package"
	echo "  cleancache  Remove downloaded files from \$SRCDEST"
	echo "  srcpkg      Make a source package"
	echo "  up2date     Compare target and sources dates"
921 922
	echo "  installdeps Install packages listed in makedepends and depends"
	echo "  uninstalldeps Uninstall packages listed in makedepends and depends"
Natanael Copa's avatar
Natanael Copa committed
923 924 925 926 927
	echo ""
	exit 0
}

APKBUILD="${APKBUILD:-./APKBUILD}"
928 929
unset force
unset recursive
930
while getopts "cfhi:kin:p:P:qrRs:u" opt; do
Natanael Copa's avatar
Natanael Copa committed
931
	case $opt in
932
		'c') cpinitd=1;;
Natanael Copa's avatar
Natanael Copa committed
933
		'f') force=1;;
934 935
		'h') usage;;
		'i') install_after="$install_after $OPTARG";;
936
		'k') keep=1;;
937
		'n') newname=$OPTARG;;
938
		'p') PKGDEST=$OPTARG;;
939
		'P') REPODEST=$OPTARG;;
Natanael Copa's avatar
Natanael Copa committed
940
		'q') quiet=1;;
941 942
		'r') install_deps=1;;
		'R') recursive=1;;
943
		's') SRCDEST=$OPTARG;;
944 945
		'u') upgrade=1
		     recursive=1;;
Natanael Copa's avatar
Natanael Copa committed
946 947 948 949
	esac
done
shift $(( $OPTIND - 1 ))

950 951 952 953 954
# If REPODEST is set then it will override the PKGDEST
if [ -n "$REPODEST" ]; then
	PKGDEST="$REPODEST/$repo"
fi

955
# source the buildfile
956 957 958 959
if [ -z "$newname" ]; then
	[ -f "$APKBUILD" ] || die "Could not find $APKBUILD (PWD=$PWD)"
	. "$APKBUILD"
fi
960

961
# If we are handling a sub package then reset subpackages and install
962 963
if [ -n "$subpkgname" ]; then
	subpackages=
964
	install=
965
fi
966
pkgdir="$pkgbasedir/$pkgname"
967
controldir="$pkgbasedir"/.control.${subpkgname:-$pkgname}
Natanael Copa's avatar
Natanael Copa committed
968 969

trap 'die "Aborted by user"' INT
Linux User's avatar
Linux User committed
970
set_xterm_title "abuild: $pkgname"
Natanael Copa's avatar
Natanael Copa committed
971

972 973 974
if [ -z "$1" ] && [ -n "$newname" ]; then
	set "newaport"
fi
Natanael Copa's avatar
Natanael Copa committed
975 976

if [ -z "$1" ]; then
977
	set all
Natanael Copa's avatar
Natanael Copa committed
978 979 980 981 982 983
fi

while [ $# -gt 0 ]; do
	runpart $1
	shift
done
984 985

for i in $install_after; do
Natanael Copa's avatar
Natanael Copa committed
986
	post_add $i
987 988
done

Linux User's avatar
Linux User committed
989
cleanup
Natanael Copa's avatar
Natanael Copa committed
990